Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungContinuous.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungContinuous.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungContinuous.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeBremsstrahlungContinuous.cc,v 1.12 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeBremsstrahlungModel.cc,v 1.7 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeCompton.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeCompton.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeCompton.cc,v 1.36 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeComptonModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeComptonModel.cc,v 1.8 2009/10/23 09:29:24 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeGammaConversionModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeGammaConversionModel.cc,v 1.6 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisation.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeIonisation.cc,v 1.22 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeIonisationModel.cc,v 1.10 2009/10/23 09:29:24 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PenelopePhotoElectric.cc,v 1.16 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: L. Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopePhotoElectricModel.cc,v 1.10 2009/10/23 09:29:24 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4PenelopeRayleigh.cc,v 1.19 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: L. Pandola (luciano.pandola@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeRayleighModel.cc,v 1.6 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4RangeTest.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4RangeTest.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4RangeTest.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4RangeTest.cc,v 1.9 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4RayleighScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4RayleighScattering.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4RayleighScattering.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4RayleighScattering.cc,v 1.2 2009/03/18 13:45:51 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4SemiLogInterpolation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4SemiLogInterpolation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4SemiLogInterpolation.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SemiLogInterpolation.cc,v 1.8 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4ShellData.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4ShellData.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4ShellData.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ShellData.cc,v 1.11 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4ShellEMDataSet.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4ShellEMDataSet.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4ShellEMDataSet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ShellEMDataSet.cc,v 1.18 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4VCrossSectionHandler.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4VCrossSectionHandler.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4VCrossSectionHandler.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VCrossSectionHandler.cc,v 1.19 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4VLowEnergyDiscretePhotonProcess.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4VLowEnergyDiscretePhotonProcess.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4VLowEnergyDiscretePhotonProcess.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VLowEnergyDiscretePhotonProcess.cc,v 1.6 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4VeLowEnergyLoss.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4VeLowEnergyLoss.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4VeLowEnergyLoss.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VeLowEnergyLoss.cc,v 1.27 2009/07/23 09:15:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4WaterExcitationStructure.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4WaterExcitationStructure.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4WaterExcitationStructure.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4WaterExcitationStructure.cc,v 1.1 2007/10/15 08:57:54 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4WaterIonisationStructure.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4WaterIonisationStructure.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4WaterIonisationStructure.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4WaterIonisationStructure.cc,v 1.1 2007/11/08 20:39:35 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eBremsstrahlungSpectrum.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eBremsstrahlungSpectrum.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eBremsstrahlungSpectrum.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eBremsstrahlungSpectrum.cc,v 1.16 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionExcitationEmfietzoglou.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionExcitationEmfietzoglou.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionExcitationEmfietzoglou.cc	(revision 1228)
@@ -26,9 +26,9 @@
 //
 // $Id: G4eCrossSectionExcitationEmfietzoglou.cc,v 1.1 2007/05/04 10:16:06 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
 // $Id: G4eCrossSectionExcitationEmfietzoglou.cc,v 1.1 2007/05/04 10:16:06 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionScreenedRutherford.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionScreenedRutherford.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eCrossSectionScreenedRutherford.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4eCrossSectionScreenedRutherford.cc,v 1.3 2007/10/12 12:27:19 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eIonisationCrossSectionHandler.cc,v 1.15 2009/09/27 10:47:42 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4eIonisationParameters.cc,v 1.25 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4eIonisationSpectrum.cc,v 1.27 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eLowEnergyLoss.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eLowEnergyLoss.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eLowEnergyLoss.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4eLowEnergyLoss.cc,v 1.37 2009/07/23 09:15:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //  
 // -----------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyIonisation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyIonisation.cc	(revision 1228)
@@ -100,7 +100,6 @@
 //               parametrised proton model: min(user value, model limit)
 // 26 Jan   2005 S. Chauvie added PrintInfoDefinition() for antiproton
-// 30 Sep   2009 ALF Removed dependencies to old shell Ionisation XS models
-// 11 Nov   2009 ALF Code cleaning for the Dec release
-//
+
+
 // -----------------------------------------------------------------------
 
@@ -122,4 +121,7 @@
 #include "G4ShellVacancy.hh"
 #include "G4VhShellCrossSection.hh"
+#include "G4hShellCrossSection.hh"
+#include "G4hShellCrossSectionExp.hh"
+#include "G4hShellCrossSectionDoubleExp.hh"
 #include "G4VEMDataSet.hh"
 #include "G4EMDataSet.hh"
@@ -130,6 +132,5 @@
 #include "G4ProcessManager.hh"
 #include "G4ProductionCutsTable.hh"
-#include "G4teoCrossSection.hh"
-#include "G4empCrossSection.hh"
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
@@ -152,5 +153,6 @@
     shellVacancy(0),
     shellCS(0),
-    theFluo(false)
+    theFluo(false),
+    expFlag(false)
 { 
   InitializeMe();
@@ -173,6 +175,16 @@
   verboseLevel         = 0;
 
-  shellCS = new G4teoCrossSection("analytical");
-
+//****************************************************************************
+// By default the method of cross section's calculation is swiched on an 
+// 2nd implementation empirical model (G4hShellCrossSectionDoubleExp), 
+// if you want to use Gryzinski's model (G4hShellCrossSection()) or the
+// 1st empiric one (G4hShellCrossSectionExp), you must change the 
+// selection below and switching expFlag to FALSE
+//****************************************************************************
+
+  //shellCS = new G4hShellCrossSection();
+  //shellCS = new G4hShellCrossSectionExp();
+  shellCS = new G4hShellCrossSectionDoubleExp();
+  expFlag=true;
 }
 
@@ -1268,58 +1280,61 @@
   //   G4cout << "Fluorescence is switched :" << theFluo << G4endl; 
 
-  // Fluorescence data start from element 6
   if(theFluo && Z > 5) {
 
 
 
-    // Atom total cross section     
+    // Atom total cross section for the Empiric Model    
+    if (expFlag) {    
     shellCS->SetTotalCS(totalCrossSectionMap[Z]);    
-
+    }
     G4int shell = shellCS->SelectRandomShell(Z, KineticEnergy,ParticleMass,DeltaKineticEnergy);
 
-    if (shell!=-1) {        
-      
-      const G4AtomicShell* atomicShell =
-	(G4AtomicTransitionManager::Instance())->Shell(Z, shell);
-      G4double bindingEnergy = atomicShell->BindingEnergy();
-      
-      if(verboseLevel > 1) {
-	G4cout << "PostStep Z= " << Z << " shell= " << shell
-	       << " bindingE(keV)= " << bindingEnergy/keV
-	       << " finalE(keV)= " << finalKineticEnergy/keV
-	       << G4endl;
-      }
-      
-      
-      
-      if (finalKineticEnergy >= bindingEnergy
-	  && (bindingEnergy >= minGammaEnergy
-	      ||  bindingEnergy >= minElectronEnergy) ) {
-	
-	G4int shellId = atomicShell->ShellId();
-	secondaryVector = deexcitationManager.GenerateParticles(Z, shellId);
-	
-	if (secondaryVector != 0) {
-	  
-	  nSecondaries = secondaryVector->size();
-	  for (size_t i = 0; i<nSecondaries; i++) {
-	    
-	    aSecondary = (*secondaryVector)[i];
-	    if (aSecondary) {
-	      
-	      G4double e = aSecondary->GetKineticEnergy();
-	      type = aSecondary->GetDefinition();
-	      if (e < finalKineticEnergy &&
-		  ((type == G4Gamma::Gamma() && e > minGammaEnergy ) ||
-		   (type == G4Electron::Electron() && e > minElectronEnergy ))) {
-		
-		finalKineticEnergy -= e;
-		totalNumber++;
-		
-	      } else {
-		
-		delete aSecondary;
-		(*secondaryVector)[i] = 0;
-	      }
+    if (expFlag && shell==1) {        
+      aParticleChange.ProposeLocalEnergyDeposit (KineticEnergy);
+      aParticleChange.ProposeEnergy(0);      
+    }
+
+
+    const G4AtomicShell* atomicShell =
+                (G4AtomicTransitionManager::Instance())->Shell(Z, shell);
+    G4double bindingEnergy = atomicShell->BindingEnergy();
+
+    if(verboseLevel > 1) {
+      G4cout << "PostStep Z= " << Z << " shell= " << shell
+             << " bindingE(keV)= " << bindingEnergy/keV
+             << " finalE(keV)= " << finalKineticEnergy/keV
+             << G4endl;
+    }
+
+    // Fluorescence data start from element 6
+
+    if (finalKineticEnergy >= bindingEnergy
+         && (bindingEnergy >= minGammaEnergy
+         ||  bindingEnergy >= minElectronEnergy) ) {
+
+      G4int shellId = atomicShell->ShellId();
+      secondaryVector = deexcitationManager.GenerateParticles(Z, shellId);
+
+      if (secondaryVector != 0) {
+
+        nSecondaries = secondaryVector->size();
+        for (size_t i = 0; i<nSecondaries; i++) {
+
+          aSecondary = (*secondaryVector)[i];
+          if (aSecondary) {
+
+            G4double e = aSecondary->GetKineticEnergy();
+            type = aSecondary->GetDefinition();
+            if (e < finalKineticEnergy &&
+                 ((type == G4Gamma::Gamma() && e > minGammaEnergy ) ||
+                  (type == G4Electron::Electron() && e > minElectronEnergy ))) {
+
+              finalKineticEnergy -= e;
+              totalNumber++;
+
+	    } else {
+
+              delete aSecondary;
+              (*secondaryVector)[i] = 0;
 	    }
 	  }
@@ -1328,5 +1343,5 @@
     }
   }
-  
+
   // Save delta-electrons
 
@@ -1386,24 +1401,6 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-
-
-void G4hLowEnergyIonisation::SelectShellIonisationCS(G4String val) {
-
-  if (shellCS) delete shellCS;
-
-  if (val == "empirical") {
-    shellCS = new G4empCrossSection();
-  }
- else {
-    shellCS = new G4teoCrossSection(val);
-  }
-}
-
-
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-
-std::vector<G4DynamicParticle*>* G4hLowEnergyIonisation::DeexciteAtom(const G4MaterialCutsCouple* couple,
+std::vector<G4DynamicParticle*>*
+G4hLowEnergyIonisation::DeexciteAtom(const G4MaterialCutsCouple* couple,
 				           G4double incidentEnergy,
 				           G4double hMass,
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4hLowEnergyLoss.cc,v 1.30 2009/07/23 09:15:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -----------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExp.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExp.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExp.cc	(revision 1228)
@@ -42,5 +42,5 @@
 // -------------------------------------------------------------------
 // $Id: G4hShellCrossSectionDoubleExp.cc,v 1.10 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "globals.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExpData.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExpData.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionDoubleExpData.cc	(revision 1228)
@@ -34,5 +34,5 @@
 // -------------------------------------------------------------------
 // $Id: G4hShellCrossSectionDoubleExpData.cc,v 1.5 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4hShellCrossSectionDoubleExpData.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExp.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExp.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExp.cc	(revision 1228)
@@ -42,5 +42,5 @@
 // -------------------------------------------------------------------
 // $Id: G4hShellCrossSectionExp.cc,v 1.7 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "globals.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExpData.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExpData.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hShellCrossSectionExpData.cc	(revision 1228)
@@ -34,5 +34,5 @@
 // -------------------------------------------------------------------
 // $Id: G4hShellCrossSectionExpData.cc,v 1.4 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4hShellCrossSectionExpData.hh"
Index: trunk/source/processes/electromagnetic/muons/include/G4EnergyLossForExtrapolator.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4EnergyLossForExtrapolator.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4EnergyLossForExtrapolator.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4EnergyLossForExtrapolator.hh,v 1.12 2008/11/13 14:14:07 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuBetheBlochModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuBetheBlochModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuBetheBlochModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuBetheBlochModel.hh,v 1.18 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlung.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlung.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlung.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuBremsstrahlung.hh,v 1.31 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlungModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlungModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuBremsstrahlungModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuBremsstrahlungModel.hh,v 1.22 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuIonisation.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuIonisation.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuIonisation.hh,v 1.31 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuMultipleScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuMultipleScattering.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuMultipleScattering.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuMultipleScattering.hh,v 1.4 2009/10/30 18:37:06 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuPairProduction.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuPairProduction.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuPairProduction.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuPairProduction.hh,v 1.31 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/include/G4MuPairProductionModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/muons/include/G4MuPairProductionModel.hh	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/include/G4MuPairProductionModel.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MuPairProductionModel.hh,v 1.28 2009/02/20 14:48:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/muons/src/G4EnergyLossForExtrapolator.cc
===================================================================
--- trunk/source/processes/electromagnetic/muons/src/G4EnergyLossForExtrapolator.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/muons/src/G4EnergyLossForExtrapolator.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4EnergyLossForExtrapolator.cc,v 1.19 2009/07/09 17:04:55 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
